## qastools 1.4.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED ( VERSION 3.25 )
PROJECT ( QasTools
    VERSION 1.4.0
    LANGUAGES CXX )


# Build type

SET ( CMAKE_BUILD_TYPE "Release" CACHE STRING "CMake build type" )
SET ( BUILD_LIST "qascommon,qasconfig,qashctl,qasmixer" CACHE STRING
      "List of parts to build" )


# program/package/version suffix

SET ( PROGRAM_SUFFIX "" CACHE STRING "Program suffix" )
SET ( VERSION_SUFFIX "" CACHE STRING "Version suffix" )
SET ( PACKAGE_SUFFIX "" CACHE STRING "Package suffix" )


# Package name

SET ( PACKAGE_TITLE "QasTools" CACHE STRING "Package title" )
SET ( PACKAGE_NAME "qastools${PACKAGE_SUFFIX}" CACHE STRING "Package name" )


# Package version

SET ( PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}" )
SET ( PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}" )
SET ( PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}" )

SET ( PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}${VERSION_SUFFIX}" )


# Installation directories

SET ( INSTALL_DIR_BIN "bin" CACHE STRING
      "Installation directory for binaries" )
SET ( INSTALL_DIR_MAN "share/man/man1" CACHE STRING
      "Installation directory for manpages" )
SET ( INSTALL_DIR_APPSTREAM "share/metainfo" CACHE STRING
      "Installation directory for AppStream metadata" )
SET ( INSTALL_DIR_DESKTOP "share/applications" CACHE STRING
      "Installation directory for desktop files" )

SET ( INSTALL_DIR_DATA "share/${PACKAGE_NAME}" CACHE STRING
      "Installation directory for application data" )
SET ( INSTALL_DIR_L10N "${INSTALL_DIR_DATA}/l10n" CACHE STRING
      "Installation directory for localization files" )
SET ( INSTALL_DIR_APP_ICONS "${INSTALL_DIR_DATA}/icons" CACHE STRING
      "Installation directory for application icons" )
SET ( INSTALL_DIR_WIDGETS_GRAPHICS "${INSTALL_DIR_DATA}/widgets" CACHE STRING
      "Installation directory for widget graphics" )


# Icon installation directories

SET ( INSTALL_DIR_ICONS_PNG_16 "share/icons/hicolor/16x16/apps" CACHE STRING
      "Installation directory for application icons (16x16)" )
SET ( INSTALL_DIR_ICONS_PNG_32 "share/icons/hicolor/32x32/apps" CACHE STRING
      "Installation directory for application icons (32x32)" )
SET ( INSTALL_DIR_ICONS_PNG_48 "share/icons/hicolor/48x48/apps" CACHE STRING
      "Installation directory for application icons (48x48)" )
SET ( INSTALL_DIR_ICONS_PNG_64 "share/icons/hicolor/64x64/apps" CACHE STRING
      "Installation directory for application icons (64x64)" )
SET ( INSTALL_DIR_ICONS_SVG "share/icons/hicolor/scalable/apps" CACHE STRING
      "Installation directory for application icons (scalable)" )


# Localization file prefix

SET ( L10N_PREFIX "${PACKAGE_NAME}_" )


# Shared resources

SET ( SHARED_RES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/shared" )
SET ( SHARED_SRC_DIR "${SHARED_RES_DIR}/src" )
SET ( SHARED_INC_DIR "${SHARED_RES_DIR}/src" )


# License

OPTION ( SKIP_LICENSE_INSTALL "Skip the license installation" OFF )
IF ( NOT SKIP_LICENSE_INSTALL )
  INSTALL( FILES "COPYING" DESTINATION ${INSTALL_DIR_DATA} )
ENDIF ( NOT SKIP_LICENSE_INSTALL )

SET ( PACKAGE_LICENSE_FILE "${CMAKE_INSTALL_PREFIX}/${INSTALL_DIR_DATA}/COPYING"
      CACHE STRING "Package license file installation path" )
SET ( PACKAGE_LICENSE_FILE_EXTERN "/usr/share/doc/qastools-common/copyright"
      CACHE STRING "External package license file" )


# Process subdirectories

IF ( ${BUILD_LIST} MATCHES "qascommon" )
  ADD_SUBDIRECTORY ( i18n )
  ADD_SUBDIRECTORY ( shared )
ENDIF ( ${BUILD_LIST} MATCHES "qascommon" )

IF ( ${BUILD_LIST} MATCHES "qasconfig" )
  ADD_SUBDIRECTORY ( qasconfig )
ENDIF ( ${BUILD_LIST} MATCHES "qasconfig" )

IF ( ${BUILD_LIST} MATCHES "qashctl" )
  ADD_SUBDIRECTORY ( qashctl )
ENDIF ( ${BUILD_LIST} MATCHES "qashctl" )

IF ( ${BUILD_LIST} MATCHES "qasmixer" )
  ADD_SUBDIRECTORY ( qasmixer )
ENDIF ( ${BUILD_LIST} MATCHES "qasmixer" )

=== i18n/CMakeLists.txt ===
# Find modules
FIND_PACKAGE ( Qt6 REQUIRED COMPONENTS LinguistTools )

# Translations source files
SET ( ts_files
  ts/app_cs.ts
  ts/app_de.ts
  ts/app_es.ts
  ts/app_he.ts
  ts/app_ru.ts
)

# Setup translations build target
QT6_ADD_TRANSLATION ( qm_files ${ts_files} )
ADD_CUSTOM_TARGET ( translations ALL DEPENDS ${qm_files} )

# Install translations
FOREACH ( qm_src ${qm_files} )
  STRING( REGEX REPLACE ".*app_" "${L10N_PREFIX}" qm_name ${qm_src} )
  INSTALL( FILES ${qm_src}
    RENAME ${qm_name}
    DESTINATION ${INSTALL_DIR_L10N} )
ENDFOREACH ( qm_src )

=== qasconfig/CMakeLists.txt ===
# Program name

SET ( PROGRAM_TITLE "QasConfig" )
SET ( PROGRAM_NAME "qasconfig${PROGRAM_SUFFIX}" )
string ( TOUPPER ${PROGRAM_NAME} PROGRAM_NAME_UCASE )


# Program version

SET ( VERSION_MAJOR ${PACKAGE_VERSION_MAJOR} )
SET ( VERSION_MINOR ${PACKAGE_VERSION_MINOR} )
SET ( VERSION_PATCH ${PACKAGE_VERSION_PATCH} )

SET ( VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX}" )


# Process subdirectories

ADD_SUBDIRECTORY ( src )
ADD_SUBDIRECTORY ( graphics )
ADD_SUBDIRECTORY ( share )

=== qashctl/CMakeLists.txt ===
# Program name

SET ( PROGRAM_TITLE "QasHCtl" )
SET ( PROGRAM_NAME "qashctl${PROGRAM_SUFFIX}" )
string ( TOUPPER ${PROGRAM_NAME} PROGRAM_NAME_UCASE )


# Program version

SET ( VERSION_MAJOR ${PACKAGE_VERSION_MAJOR} )
SET ( VERSION_MINOR ${PACKAGE_VERSION_MINOR} )
SET ( VERSION_PATCH ${PACKAGE_VERSION_PATCH} )

SET ( VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX}" )


# Process subdirectories

ADD_SUBDIRECTORY ( src )
ADD_SUBDIRECTORY ( graphics )
ADD_SUBDIRECTORY ( share )

=== qasmixer/CMakeLists.txt ===
# Program name

SET ( PROGRAM_TITLE "QasMixer" )
SET ( PROGRAM_NAME "qasmixer${PROGRAM_SUFFIX}" )
string ( TOUPPER ${PROGRAM_NAME} PROGRAM_NAME_UCASE )


# Program version

SET ( VERSION_MAJOR ${PACKAGE_VERSION_MAJOR} )
SET ( VERSION_MINOR ${PACKAGE_VERSION_MINOR} )
SET ( VERSION_PATCH ${PACKAGE_VERSION_PATCH} )

SET ( VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX}" )


# Process subdirectories

ADD_SUBDIRECTORY ( src )
ADD_SUBDIRECTORY ( graphics )
ADD_SUBDIRECTORY ( share )

=== qasconfig/share/CMakeLists.txt ===
# Desktop file

SET ( desktop_file_in "${CMAKE_CURRENT_SOURCE_DIR}/application.desktop" )
SET ( desktop_file    "${CMAKE_CURRENT_BINARY_DIR}/${PROGRAM_NAME}.desktop" )

CONFIGURE_FILE ( ${desktop_file_in} ${desktop_file} )

INSTALL( FILES ${desktop_file} DESTINATION ${INSTALL_DIR_DESKTOP} )

# AppStream meta data

SET ( appstream_file_in "${CMAKE_CURRENT_SOURCE_DIR}/application.appdata.xml" )
SET ( appstream_file    "${CMAKE_CURRENT_BINARY_DIR}/${PROGRAM_NAME}.appdata.xml" )

CONFIGURE_FILE ( ${appstream_file_in} ${appstream_file} )

INSTALL ( FILES ${appstream_file} DESTINATION ${INSTALL_DIR_APPSTREAM} )

# Subdirectories

ADD_SUBDIRECTORY ( man )

=== qashctl/src/CMakeLists.txt ===
# --- Find modules

FIND_PACKAGE (
  Qt6
  COMPONENTS
    Widgets
    Svg
  REQUIRED )
FIND_PACKAGE ( ALSA REQUIRED )

# TODO: FIND_PACKAGE
SET ( UDEV_LIBRARIES udev )


# --- Configure files

INCLUDE ( CheckIncludeFiles )
CONFIGURE_FILE (
  ${SHARED_SRC_DIR}/qastools_config.hpp.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/qastools_config.hpp )


# --- Sources

SET ( SRC_GUI
  ${SHARED_SRC_DIR}/qsnd/alsa.cpp
  ${SHARED_SRC_DIR}/qsnd/alsa_config_watcher.cpp
  ${SHARED_SRC_DIR}/qsnd/event_types.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address.cpp
  ${SHARED_SRC_DIR}/qsnd/card_info.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_db.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_model.cpp
  ${SHARED_SRC_DIR}/qsnd/hctl/elem.cpp
  ${SHARED_SRC_DIR}/qsnd/hctl/elem_group.cpp
  ${SHARED_SRC_DIR}/qsnd/hctl/info_db.cpp
  ${SHARED_SRC_DIR}/qsnd/hctl/mixer.cpp
  ${SHARED_SRC_DIR}/qsnd/mixers_model.cpp
  ${SHARED_SRC_DIR}/qsnd/udev_device_lookout.cpp

  ${SHARED_SRC_DIR}/dpe/image_allocator.cpp
  ${SHARED_SRC_DIR}/dpe/image.cpp
  ${SHARED_SRC_DIR}/dpe/image_request.cpp
  ${SHARED_SRC_DIR}/dpe/image_set.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_group.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_meta.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_state.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer_handle.cpp
  ${SHARED_SRC_DIR}/dpe/painter.cpp
  ${SHARED_SRC_DIR}/dpe/painter_simple.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread_shared.cpp
  ${SHARED_SRC_DIR}/dpe/paint_job.cpp

  ${SHARED_SRC_DIR}/wdg/label_width.cpp
  ${SHARED_SRC_DIR}/wdg/label_elide.cpp
  ${SHARED_SRC_DIR}/wdg/tree_view_kv.cpp
  ${SHARED_SRC_DIR}/wdg/text_browser.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_horizontal.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_vertical.cpp
  ${SHARED_SRC_DIR}/wdg/color_methods.cpp
  ${SHARED_SRC_DIR}/wdg/cubic_curve.cpp
  ${SHARED_SRC_DIR}/wdg/uint_mapper.cpp
  ${SHARED_SRC_DIR}/wdg/ds/imaging.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/slider_bevelled.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/switch_circle.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/switch_svg.cpp
  ${SHARED_SRC_DIR}/wdg/ds/slider.cpp
  ${SHARED_SRC_DIR}/wdg/ds/slider_meta_bg.cpp
  ${SHARED_SRC_DIR}/wdg/ds/switch.cpp
  ${SHARED_SRC_DIR}/wdg/event_types.cpp
  ${SHARED_SRC_DIR}/wdg/pass_events.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/column.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/group.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/proxy.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/enum.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/slider.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/style.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/switch.cpp
  ${SHARED_SRC_DIR}/wdg/pad_focus_info.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/column.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/group.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/index.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/row.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/weights.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/pad.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data_column.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data_group.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/footer.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header_label.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/style.cpp
  ${SHARED_SRC_DIR}/wdg/style_db.cpp

  ${SHARED_SRC_DIR}/mwdg/event_types.cpp
  ${SHARED_SRC_DIR}/mwdg/inputs_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_device_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_style_db.cpp
  ${SHARED_SRC_DIR}/mwdg/mixers_delegate.cpp
  ${SHARED_SRC_DIR}/mwdg/mixers_view.cpp
  ${SHARED_SRC_DIR}/mwdg/slider_status_widget.cpp
  ${SHARED_SRC_DIR}/mwdg/user_device_input.cpp

  ${SHARED_SRC_DIR}/views/view_utility.cpp
  ${SHARED_SRC_DIR}/views/message_widget.cpp
  ${SHARED_SRC_DIR}/views/view_base_setup.cpp
  ${SHARED_SRC_DIR}/views/view_base.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view_setup.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view.cpp
  ${SHARED_SRC_DIR}/views/basic_dialog.cpp
  ${SHARED_SRC_DIR}/views/multi_page_dialog.cpp
  ${SHARED_SRC_DIR}/views/info_dialog.cpp

  ${SHARED_SRC_DIR}/license_texts.cpp

  mwdg/hctl/mixer.cpp
  mwdg/hctl/edit/bool.cpp
  mwdg/hctl/edit/enum.cpp
  mwdg/hctl/edit/int.cpp
  mwdg/hctl/edit/unsupported.cpp
  mwdg/hctl/editor.cpp
  mwdg/hctl/editor_data.cpp
  mwdg/hctl/int_proxy/group.cpp
  mwdg/hctl/int_proxy/column.cpp
  mwdg/hctl/int_proxy/slider.cpp
  mwdg/hctl/proxy/group.cpp
  mwdg/hctl/proxy/proxy.cpp
  mwdg/hctl/proxy/enum.cpp
  mwdg/hctl/proxy/switch.cpp
  mwdg/hctl/slider_status_widget.cpp
  mwdg/hctl/table_model.cpp
  mwdg/hctl/tree_model.cpp

  views/mixer_hctl_setup.cpp
  views/mixer_hctl.cpp

  info_texts.cpp
  init_globals.cpp
  main_window_setup.cpp
  main_window.cpp
  desktop_items.cpp
  main.cpp
)


# --- Compiler flags

SET ( CMAKE_CXX_STANDARD 17 )
SET ( CMAKE_CXX_STANDARD_REQUIRED ON )
SET ( CMAKE_CXX_EXTENSIONS OFF )
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wunused -Wall" )
SET ( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -fno-inline" )
SET ( CMAKE_CXX_FLAGS_RELEASE "-O2 ${CMAKE_CXX_FLAGS_RELEASE}" )


# --- Include directories

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR} )
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR} )
INCLUDE_DIRECTORIES ( ${SHARED_INC_DIR} )
INCLUDE_DIRECTORIES ( ${ALSA_INCLUDE_DIRS} )


# --- Executable

ADD_EXECUTABLE ( ${PROGRAM_NAME}
  ${SRC_GUI}
  ${SRC_GUI_MOC}
)
SET_TARGET_PROPERTIES ( ${PROGRAM_NAME} PROPERTIES AUTOMOC ON )
TARGET_LINK_LIBRARIES ( ${PROGRAM_NAME}
  Qt6::Widgets
  Qt6::Svg
  ${ALSA_LIBRARIES}
  ${UDEV_LIBRARIES}
)


# --- Installation

INSTALL (
  TARGETS ${PROGRAM_NAME} RUNTIME
  DESTINATION ${INSTALL_DIR_BIN} )

=== qasmixer/src/CMakeLists.txt ===
# --- Find modules

FIND_PACKAGE (
  Qt6
  COMPONENTS
    Core
    DBus
    Widgets
    Svg
    Network
  REQUIRED )
FIND_PACKAGE ( ALSA REQUIRED )

# TODO: FIND_PACKAGE
SET ( UDEV_LIBRARIES udev )


# --- Configure files

INCLUDE ( CheckIncludeFiles )
CONFIGURE_FILE (
  ${SHARED_SRC_DIR}/qastools_config.hpp.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/qastools_config.hpp )


# --- Sources

SET ( SRC_GUI
  ${SHARED_SRC_DIR}/qsnd/alsa.cpp
  ${SHARED_SRC_DIR}/qsnd/event_types.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_db.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_model.cpp
  ${SHARED_SRC_DIR}/qsnd/card_info.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer/mixer.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer/elem.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer/filter.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer/filters/first_playback_volume.cpp
  ${SHARED_SRC_DIR}/qsnd/mixers_model.cpp
  ${SHARED_SRC_DIR}/qsnd/udev_device_lookout.cpp

  ${SHARED_SRC_DIR}/dpe/image.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_meta.cpp
  ${SHARED_SRC_DIR}/dpe/image_set.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_group.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_state.cpp
  ${SHARED_SRC_DIR}/dpe/image_request.cpp
  ${SHARED_SRC_DIR}/dpe/image_allocator.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer_handle.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer.cpp
  ${SHARED_SRC_DIR}/dpe/paint_job.cpp
  ${SHARED_SRC_DIR}/dpe/painter.cpp
  ${SHARED_SRC_DIR}/dpe/painter_simple.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread_shared.cpp

  ${SHARED_SRC_DIR}/wdg/label_elide.cpp
  ${SHARED_SRC_DIR}/wdg/label_styled.cpp
  ${SHARED_SRC_DIR}/wdg/label_width.cpp
  ${SHARED_SRC_DIR}/wdg/text_browser.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_horizontal.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_vertical.cpp
  ${SHARED_SRC_DIR}/wdg/color_methods.cpp
  ${SHARED_SRC_DIR}/wdg/ds/imaging.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/slider_bevelled.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/switch_circle.cpp
  ${SHARED_SRC_DIR}/wdg/ds/painter/switch_svg.cpp
  ${SHARED_SRC_DIR}/wdg/ds/slider.cpp
  ${SHARED_SRC_DIR}/wdg/ds/slider_meta_bg.cpp
  ${SHARED_SRC_DIR}/wdg/ds/switch.cpp
  ${SHARED_SRC_DIR}/wdg/cubic_curve.cpp
  ${SHARED_SRC_DIR}/wdg/event_types.cpp
  ${SHARED_SRC_DIR}/wdg/pass_events.cpp
  ${SHARED_SRC_DIR}/wdg/pad_focus_info.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/proxy.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/style.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/slider.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/switch.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/enum.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/column.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy/group.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/column.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/group.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/index.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/row.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/equal_columns/weights.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/style.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data_column.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/data_group.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header_label.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/header.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/footer.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad/pad.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/fill_columns/item.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/fill_columns/layout.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/widgets_group.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/widgets_set.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/pad.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad/scroll_area.cpp
  ${SHARED_SRC_DIR}/wdg/uint_mapper.cpp
  ${SHARED_SRC_DIR}/wdg/style_db.cpp

  ${SHARED_SRC_DIR}/mwdg/event_types.cpp
  ${SHARED_SRC_DIR}/mwdg/inputs_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_device_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_style_db.cpp
  ${SHARED_SRC_DIR}/mwdg/mixers_delegate.cpp
  ${SHARED_SRC_DIR}/mwdg/mixers_view.cpp
  ${SHARED_SRC_DIR}/mwdg/slider_status_widget.cpp
  ${SHARED_SRC_DIR}/mwdg/user_device_input.cpp

  ${SHARED_SRC_DIR}/views/view_utility.cpp
  ${SHARED_SRC_DIR}/views/message_widget.cpp
  ${SHARED_SRC_DIR}/views/view_base_setup.cpp
  ${SHARED_SRC_DIR}/views/view_base.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view_setup.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view.cpp
  ${SHARED_SRC_DIR}/views/basic_dialog.cpp
  ${SHARED_SRC_DIR}/views/multi_page_dialog.cpp
  ${SHARED_SRC_DIR}/views/info_dialog.cpp

  ${SHARED_SRC_DIR}/unix_signal_handler.cpp
  ${SHARED_SRC_DIR}/single_application.cpp
  ${SHARED_SRC_DIR}/license_texts.cpp

  mstate/mixer/controls.cpp
  mstate/mixer/state.cpp
  mstate/mixer/states_db.cpp

  mwdg/mixer/proxy/column.cpp
  mwdg/mixer/proxy/group.cpp
  mwdg/mixer/proxies_model.cpp
  mwdg/mixer/proxies_settings_model.cpp
  mwdg/mixer/proxy_identifier.cpp
  mwdg/mixer/setup.cpp
  mwdg/mixer/sliders/mixer.cpp
  mwdg/mixer/sliders/proxies_model.cpp
  mwdg/mixer/sliders/proxy/column.cpp
  mwdg/mixer/sliders/proxy/group.cpp
  mwdg/mixer/sliders/proxy/slider.cpp
  mwdg/mixer/sliders/proxy/switch.cpp
  mwdg/mixer/sliders/status_widget.cpp
  mwdg/mixer/switches/mixer.cpp
  mwdg/mixer/switches/proxies_model.cpp
  mwdg/mixer/switches/proxy/column.cpp
  mwdg/mixer/switches/proxy/group.cpp
  mwdg/mixer/switches/proxy/enum.cpp
  mwdg/mixer/switches/proxy/switch.cpp
  mwdg/stream_view_selection.cpp
  mwdg/stream_view_selection_actions.cpp

  views/device_settings_dialog.cpp
  views/device_settings_dialog_setup.cpp
  views/device_selection_bar.cpp
  views/mixer_setup.cpp
  views/mixer.cpp
  views/settings_dialog_setup.cpp
  views/settings_dialog.cpp

  tray/icon.cpp
  tray/mixer.cpp
  tray/mixer_dev_setup.cpp
  tray/notifier.cpp
  tray/shared.cpp
  tray/view_setup.cpp
  
  cmd_options.cpp
  main_window_setup.cpp
  main_window.cpp
  desktop_items_setup.cpp
  desktop_items.cpp

  init_globals.cpp
  info_texts.cpp
  main.cpp
)


# --- Compiler flags

SET ( CMAKE_CXX_STANDARD 17 )
SET ( CMAKE_CXX_STANDARD_REQUIRED ON )
SET ( CMAKE_CXX_EXTENSIONS OFF )
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wunused -Wall" )
SET ( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -fno-inline" )
SET ( CMAKE_CXX_FLAGS_RELEASE "-O2 ${CMAKE_CXX_FLAGS_RELEASE}" )


# --- Include directories

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR} )
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR} )
INCLUDE_DIRECTORIES ( ${SHARED_INC_DIR} )
INCLUDE_DIRECTORIES ( ${ALSA_INCLUDE_DIRS} )


# --- Executable

ADD_EXECUTABLE ( ${PROGRAM_NAME}
  ${SRC_GUI}
)
SET_TARGET_PROPERTIES ( ${PROGRAM_NAME} PROPERTIES AUTOMOC ON )
TARGET_LINK_LIBRARIES ( ${PROGRAM_NAME}
  Qt6::DBus
  Qt6::Widgets
  Qt6::Svg
  Qt6::Network
  ${ALSA_LIBRARIES}
  ${UDEV_LIBRARIES}
)


# --- Installation

INSTALL (
  TARGETS ${PROGRAM_NAME} RUNTIME
  DESTINATION ${INSTALL_DIR_BIN} )

=== debian/changelog ===
qastools (1.4.0-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:21:36 +0000

qastools (1.4.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:05:32 +0000

qastools (1.4.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:55:53 +0000

qastools (1.4.0-1) unstable; urgency=medium

  * Upstream release v1.4.0:
    - QasHCtl,QasMixer: Reload mixer when ALSA signalizes a
      control add/remove/change
    - QasHCtl: Remember left splitter position
    - QasHCtl: Expand level 0 items in the tree view by default
    - QasMixer: New mixer device settings dialog
    - QasMixer: Controls can be hidden
    - QasMixer: Controls can be sorted by playback and capture
    - QasMixer: Control tooltips can be enabled/disabled in the settings
    - QasMixer: Remember separation state for each control
    - QasMixer: Remember vertical splitter position for each mixer device
    - QasMixer: Remember show playback and capture for each mixer device
    - QasMixer: New separators in the device selection view
    - QasMixer: Tray mixer: Use first available playback control even if it
      is not Master
    - CMake: Bring back SKIP_LICENSE_INSTALL option and external license file
    - Code refactoring and modernization
    - Bug fixes
  * Upstream release v1.3.0:
    - README.md: Update the build examples to use git and add localization info
    - L10n: Add LOCALIZATION.md with information about how to translate
      QasTools
    - L10n: Update the german translation
    - Apps: Add "About Qt" dialog in the help menu
    - CMake: Remove SKIP_LICENSE_INSTALL flag
      We need the COPYING file in the about dialog
    - Apps: About dialog: Don't show GPL-3 license, we use MIT license
    - Apps: Add content_rating attributes in the appdata.xml files
    - QasMixer: Add show playback and show capture actions to the View menu
    - QasMixer: New device info dialog
    - QasMixer: To properly raise the window call activateWindow() before
      raise()
    - QasMixer: Show volume change desktop notifications by default
    - QasMixer: Use desktop notifications instead of a custom balloon widget
      to show volume change information
    - QasMixer: Use playback or capture colors for switches and labels
    - QasMixer: Use the custom round switch widget in the switches pad
    - QasMixer,QasHctl: Always reload a mixer when a device is selected
      even when the address didn't change
    - QasMixer,QasHctl: Select cards by their id string to allow correct
      card selection restore after a reboot
    - QasMixer: Recognize cards by either their index or their id string
      when hw:* addresses are given
    - QasMixer,QasHctl: Layout and color tweaks
    - Code refactoring and modernization
  * debian/copyright:
    - Update copyright dates to 2024

 -- Sebastian Holtermann <sebholt@web.de>  Tue, 13 Feb 2024 16:19:14 +0100

qastools (1.2.0-1) unstable; urgency=medium

  * New upstream release.
    - Dark theme support
    - Slider appearance slightly cleaned up
    - Code cleanups, refactoring and modernization

 -- Sebastian Holtermann <sebholt@web.de>  Fri, 15 Dec 2023 19:08:46 +0100

qastools (1.1.0-1) unstable; urgency=medium

  * New upstream release.
    - GUI: Simplify the device selection
    - GUI: Sort sound cards by their ALSA index
    - GUI: Fix unnecessarily elided slider labels
    - QasMixer: Show playback and capture streams by default
    - QasMixer: Show device selection by default
    - QasMixer: Don't show the volume change balloon by default
    - L10N: Add some more ALSA element names to the translation table
    - Engine: Limit the number of painter threads to 8
    - Code: Refactoring and modernization

 -- Sebastian Holtermann <sebholt@web.de>  Fri, 08 Dec 2023 19:12:04 +0100

qastools (1.0.0-1) unstable; urgency=medium

  * New upstream release.
    - Code: Port from Qt5 to Qt6
    - Apps: Update AppStream .appdata.xml meta information files
  * debian/control:
    - Build-Depends updated for Qt6
    - Bump debhelper from old 12 to 13
    - Standards-Version raised to 4.6.2
  * debian/copyright:
    - Update dates from 2020 to 2023
  * debian/upstream/metadata:
    - Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse

 -- Sebastian Holtermann <sebholt@web.de>  Mon, 27 Nov 2023 18:23:42 +0100

=== debian/control ===
Source: qastools
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Sebastian Holtermann <sebholt@web.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libasound2-dev,
 libudev-dev,
 qt6-base-dev,
 qt6-tools-dev,
 qt6-svg-dev,
 scour,
 python3-gi-cairo,
 gir1.2-rsvg-2.0
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/sebholt/qastools
Vcs-Git: https://salsa.debian.org/multimedia-team/qastools.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qastools

Package: qastools-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: QasTools common files
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 This package contains common files shared by all applications.

Package: qasconfig
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: ALSA configuration browser
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 ALSA's configuration resides in a tree structure which gets built
 from the contents of the files /etc/asound.conf and ~/.asoundrc.
 QasConfig is a simple browser for this configuration tree and can
 help to analyze and debug an ALSA setup.

Package: qashctl
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: mixer for ALSA's High level Control Interface
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 QasHctl is a mixer application for ALSA's
 "High level Control Interface". This interface allows more complex
 interaction than the "Simple Mixer Interface" which is used by
 alsamixer and QasMixer.

Package: qasmixer
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: ALSA mixer for the desktop
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 QasMixer is a desktop mixer application for ALSA's
 "Simple Mixer Interface" and offers features similar to alsamixer.
 It also features a system tray icon with basic mixer functionality.
